/**
 * @name exports
 * @summary InsurancePlanCoverageBenefit Class
 */
module.exports = class InsurancePlanCoverageBenefit {
	constructor(opts) {
		// Create an object to store all props
		Object.defineProperty(this, '__data', { value: {} });

		// Define getters and setters as enumerable

		Object.defineProperty(this, '_id', {
			enumerable: true,
			get: () => this.__data._id,
			set: value => {
				if (value === undefined || value === null) {
					return;
				}

				let Element = require('./element.js');
				this.__data._id = new Element(value);
			},
		});

		Object.defineProperty(this, 'id', {
			enumerable: true,
			get: () => this.__data.id,
			set: value => {
				if (value === undefined || value === null) {
					return;
				}

				this.__data.id = value;
			},
		});

		Object.defineProperty(this, 'extension', {
			enumerable: true,
			get: () => this.__data.extension,
			set: value => {
				if (value === undefined || value === null) {
					return;
				}

				let Extension = require('./extension.js');
				this.__data.extension = Array.isArray(value) ? value.map(v => new Extension(v)) : [new Extension(value)];
			},
		});

		Object.defineProperty(this, 'modifierExtension', {
			enumerable: true,
			get: () => this.__data.modifierExtension,
			set: value => {
				if (value === undefined || value === null) {
					return;
				}

				let Extension = require('./extension.js');
				this.__data.modifierExtension = Array.isArray(value)
					? value.map(v => new Extension(v))
					: [new Extension(value)];
			},
		});

		Object.defineProperty(this, 'type', {
			enumerable: true,
			get: () => this.__data.type,
			set: value => {
				if (value === undefined || value === null) {
					return;
				}

				let CodeableConcept = require('./codeableconcept.js');
				this.__data.type = new CodeableConcept(value);
			},
		});

		Object.defineProperty(this, '_requirement', {
			enumerable: true,
			get: () => this.__data._requirement,
			set: value => {
				if (value === undefined || value === null) {
					return;
				}

				let Element = require('./element.js');
				this.__data._requirement = new Element(value);
			},
		});

		Object.defineProperty(this, 'requirement', {
			enumerable: true,
			get: () => this.__data.requirement,
			set: value => {
				if (value === undefined || value === null) {
					return;
				}

				this.__data.requirement = value;
			},
		});

		Object.defineProperty(this, 'limit', {
			enumerable: true,
			get: () => this.__data.limit,
			set: value => {
				if (value === undefined || value === null) {
					return;
				}

				let InsurancePlanCoverageBenefitLimit = require('./insuranceplancoveragebenefitlimit.js');
				this.__data.limit = Array.isArray(value)
					? value.map(v => new InsurancePlanCoverageBenefitLimit(v))
					: [new InsurancePlanCoverageBenefitLimit(value)];
			},
		});

		// Merge in any defaults
		Object.assign(this, opts);

		// Define a default non-writable resourceType property
		Object.defineProperty(this, 'resourceType', {
			value: 'InsurancePlanCoverageBenefit',
			enumerable: true,
			writable: false,
		});
	}

	static get resourceType() {
		return 'InsurancePlanCoverageBenefit';
	}

	toJSON() {
		return {
			_id: this._id && this._id.toJSON(),
			id: this.id,
			extension: this.extension && this.extension.map(v => v.toJSON()),
			modifierExtension: this.modifierExtension && this.modifierExtension.map(v => v.toJSON()),
			type: this.type && this.type.toJSON(),
			_requirement: this._requirement && this._requirement.toJSON(),
			requirement: this.requirement,
			limit: this.limit && this.limit.map(v => v.toJSON()),
		};
	}
};
